#include "mm.hh"
#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/mman.h>

FILE* dataFile;
char* data;
int* heapPointer; 
int loadPointer;

bool onMemory;
bool readOnly;

int 
dataStored()
{
  return *heapPointer-loadPointer;
}

bool
initMM(char* fname, int maxSize, bool onMemory_)
{
  readOnly=false;
  dataFile=fopen(fname, "a+");
  if (!dataFile) {
    readOnly=true;
    dataFile=fopen(fname, "r");
    if (!dataFile) {
      printf("Tried to open %s\n", fname);
      perror("Could not open database");
      exit(1);
    }
  }
  onMemory=onMemory_;
  if (onMemory) {
    data=(char*)mmap(0, maxSize, PROT_READ+(readOnly?0:PROT_WRITE), MAP_PRIVATE, fileno(dataFile), 0);
  } else {
    data=(char*)mmap(0, maxSize, PROT_READ+(readOnly?0:PROT_WRITE), MAP_SHARED, fileno(dataFile), 0);
  }
  if ((int)data==-1) {
    perror("Could not mmap() database");
    exit(1);
  }
  struct stat dbStat;
  fstat(fileno(dataFile), &dbStat);
  if (dbStat.st_size<int(sizeof(int))) {
    heapPointer=(int*)data;
    loadPointer=0;
    ftruncate(fileno(dataFile), sizeof(int));
    *heapPointer=sizeof(int);
    return false; // no, an older database wasn't found
  } else {
    heapPointer=(int*)data;
    loadPointer=*heapPointer;
    return true;
  }
}

void
doneMM()				    
{					    
  if (onMemory && !readOnly) {
    fseek(dataFile, loadPointer, SEEK_SET);
    fwrite(data, 1, *heapPointer-loadPointer, dataFile);
  }
  fclose(dataFile);
}

void* mmAlloc(int bytes)
return o
{
  o=data+*heapPointer;
  (*heapPointer)+=bytes;
  ftruncate(fileno(dataFile), *heapPointer);
}
